using System.Collections.Generic;
using System.Linq;
using Edu.Common.Enum;
using Edu.Model.Entity.Finance;
using Edu.Model.ViewModel.Finance;

namespace Edu.Repository.Finance
{
    /// <summary>
    /// 客户账户仓储层
    /// </summary>
    public partial class RB_ClientBankAccountRepository : BaseRepository<RB_ClientBankAccount>
    {
        /// <summary>
        /// 表名称
        /// </summary>
        public string TableName { get { return nameof(RB_ClientBankAccount); } }
 
        /// <summary>
        /// 根据查询条件获取客户账户列表
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public List<RB_ClientBankAccount> GetList(RB_ClientBankAccount_Extend model)
        {
            string where = " WHERE 1=1 ";
            where += string.Format(" AND " + nameof(RB_ClientBankAccount.Status) + "={0} ", (int)DateStateEnum.Normal);
            if (model.RB_Group_Id > 0)
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.RB_Group_Id) + "={0} ", model.RB_Group_Id);
            }
            if (model.RB_Branch_Id >= 0)
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.RB_Branch_Id) + "={0} ", model.RB_Branch_Id);
            }
            if (model.ID > 0)
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.ID) + "={0} ", model.ID);
            }
            if (!string.IsNullOrWhiteSpace(model.ClientIdStr))
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.ID) + " in({0}) ", model.ClientIdStr);
            }
            if (model.Type > 0)
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.Type) + "={0}", (int)model.Type);
            }
            if (model.ObjID > 0)
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.ObjID) + "={0}", model.ObjID);
            }
            if (!string.IsNullOrWhiteSpace(model.ObjIdStr))
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.ObjID) + " in({0})", model.ObjIdStr);
            }
            if (!string.IsNullOrEmpty(model.AccountAlias))
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.AccountAlias) + "='{0}'", model.AccountAlias);
            }
            if (!string.IsNullOrEmpty(model.CardNum))
            {
                where += string.Format(" AND " + nameof(RB_ClientBankAccount.CardNum) + " like '%{0}%' ", model.CardNum);
            }
            return Get<RB_ClientBankAccount>("select * from " + TableName + " " + where).ToList();
        }
    }
}
